----------------------------------------------------------------------
--notifiers
----------------------------------------------------------------------
function start()  
renoise.song().selected_track_index_observable:add_notifier(function()
   match_instr_to()
    end)
end
----------------------------------------------------------------------
renoise.tool().app_new_document_observable:add_notifier (
 function() start() end
)

--Auto insert instrument 
----------------------------------------------------------------------
-- renoise.tool():add_keybinding {
--  name = "Global:Tools:Insert instrument no. to pattern",
 -- invoke = function() insert_instrument() end
--}



----------------------------------------------------------------------
--Menu entry
----------------------------------------------------------------------

local options = renoise.Document.create {
  capture_enabled = false
}
renoise.tool().preferences = options

renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:Auto-Capture From 1st Note",
  selected = function() return options.capture_enabled.value end,
  invoke = function() 
    options.capture_enabled.value = not options.capture_enabled.value 
  end
}




----------------------------------------------------------------
--Converts decimal number to it`s equivalent hex string
----------------------------------------------------------------

function num_to_hex_string(num)
 
  num = tostring(num)
  num = string.format("%X",num)  

    if #num < 2 then
      return tostring("0"..num)
    end

  return num --string
end




-----------------------------------------------------------------
--main function()
-----------------------------------------------------------------

function match_instr_to()

if (options.capture_enabled.value) then

--renoise.app():show_status("Processing Please Wait...")


-----------------------------------------------------------------
--Iterate over pattern and return table
-----------------------------------------------------------------

local inst_val_tabl = {}
local pattern_iter = renoise.song().pattern_iterator
local track_index = renoise.song().selected_track_index 
local incrementer = 1

 
  if  renoise.song().tracks[track_index].visible_note_columns == 0 then do end
  -- Zero is returned when send/ master selected
 
  else

  local pos_holder = 0
  local position_in_sequencer = 0
  local total_patterns = #renoise.song().patterns
 

  for pos,line in pattern_iter:note_columns_in_track(track_index) do
    
    if pos.pattern ~= pos_holder then
      position_in_sequencer = position_in_sequencer + 1
      pos_holder = pos.pattern
      
      if position_in_sequencer > 1  then --stops "flashy" status when inst number has already been addded to cell 1   
        renoise.app():show_status("Autocapture Tool:  (Checking Pattern : "
        ..position_in_sequencer.." / "..total_patterns..")")
      end
    end
                              
    if line.instrument_value ~= 255 and true then do --> docs--[instrument_value, 0-254, 255==Empty]
      inst_val_tabl[incrementer] = line.instrument_value
      incrementer = incrementer + 1 --so we can capture the first note in pos 1 of table
      break
    end
  end
end
end


---------------------------------------------------------------------------
-- Add Instrument number to line 1
----------------------------------------------------------------------------

local inst_number = inst_val_tabl[1]-- check_for_notes_inst_num(inst_val_tabl_table)
local temp_inst_number = inst_val_tabl[1]


if inst_number == nil then temp_inst_number = 255

end


  if temp_inst_number < 255  then do --set
    local pattern_1 = renoise.song().sequencer.pattern_sequence[1]
    renoise.song().patterns[pattern_1].tracks[track_index].lines[1].note_columns[1].instrument_value = inst_number
  end

end




-------------------------------------------------------------------
--Sort response 
-------------------------------------------------------------------   

  
   if  inst_number == 255  then
     renoise.song().selected_instrument_index = 1
        elseif inst_number == nil then -- this means there are no notes found in track
     
        
          --renoise.song().selected_instrument_index = #renoise.song().instruments
          renoise.app():show_status("Autocapture Tool: (Track Is Empty, No Instrument To Capture:)")
   
        else
          if #renoise.song().instruments >=  inst_number +1 then
             renoise.song().selected_instrument_index = inst_number +1
             inst_number = num_to_hex_string(inst_number)
             renoise.app():show_status("Autocapture Tool: (Captured Instrument Number = "..inst_number..")")
          else
            renoise.app():show_status("Autocapture Tool: (First Instrument Number is not valid!)")
       end     
    end
  end
end
